package alarmclock;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import javax.sound.sampled.*;
import java.io.*;

/**
 * Title:        Homework #3
 * Description:  Alarm clock
 * Copyright:    Copyright (c) 2002
 * Company:      University of Maryland
 * @author Daniel Camara
 * @version 1.0
 */

public class AlarmClock extends JFrame implements Runnable  {
  Thread thread; // this thread
  Calendar lastAllarm = Calendar.getInstance(); //complete alarm time
  String oldDate; //calendar old date
  String oldTime; //calendar old date
  long priorTime;
  Clip clip; // the sound
  Random random; // randomic number gennerator

  JPanel contentPane;
  JPanel jPanel1 = new JPanel();
  GridLayout gridLayout2 = new GridLayout();
  BorderLayout borderLayout1 = new BorderLayout();
  FileWriter fw;

  JButton stopAlarmButton = new JButton(new ImageIcon("target2.jpg"));
  boolean alarmStoped = false; //if the alarm was stoped
  boolean isRinging = false;
  String[] alarmStrings;


  JPanel jPanel3 = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JLabel setAlarmTimes = new JLabel();
  JPanel jPanel4 = new JPanel();
  JPanel jPanel5 = new JPanel();
  JPanel jPanel6 = new JPanel();
  JPanel jPanel7 = new JPanel();
  JPanel jPanel8 = new JPanel();
  JPanel jPanel9 = new JPanel();
  JPanel jPanel10 = new JPanel();
  JPanel jPanel11 = new JPanel();
  BorderLayout borderLayout4 = new BorderLayout();
  BorderLayout borderLayout5 = new BorderLayout();
  BorderLayout borderLayout6 = new BorderLayout();
  BorderLayout borderLayout7 = new BorderLayout();
  BorderLayout borderLayout8 = new BorderLayout();
  BorderLayout borderLayout9 = new BorderLayout();
  BorderLayout borderLayout10 = new BorderLayout();
  JTextField alarmSunday = new JTextField();
  JCheckBox sundayCheckBox = new JCheckBox();
  JCheckBox mondayCheckBox = new JCheckBox();
  JTextField alarmMonday = new JTextField();
  JCheckBox tuesdayCheckBox = new JCheckBox();
  JTextField alarmTuesday = new JTextField();
  JCheckBox wednesdayCheckBox = new JCheckBox();
  JTextField alarmWednesday = new JTextField();
  JCheckBox thusdayCheckBox = new JCheckBox();
  JTextField alarmThusday = new JTextField();
  JTextField alarmFriday = new JTextField();
  JCheckBox fridayCheckBox = new JCheckBox();
  JCheckBox saturdayCheckBox = new JCheckBox();
  JTextField alarmSaturday = new JTextField();
  JLabel padding = new JLabel();
  JPanel jPanel12 = new JPanel();
  BorderLayout borderLayout11 = new BorderLayout();
  BorderLayout borderLayout15 = new BorderLayout();
  JTextField newDateField = new JTextField();
  JLabel setDateLabel = new JLabel();
  JPanel jPanel16 = new JPanel();
  JPanel jPanel13 = new JPanel();
  JPanel jPanel15 = new JPanel();
  BorderLayout borderLayout12 = new BorderLayout();
  BorderLayout borderLayout14 = new BorderLayout();
  JLabel setDateLabel1 = new JLabel();
  BorderLayout borderLayout13 = new BorderLayout();
  JPanel jPanel14 = new JPanel();
  JTextField newTimeField = new JTextField();
  JLabel padding1 = new JLabel();
  JLabel padding2 = new JLabel();
  JPanel jPanel2 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel jPanel17 = new JPanel();
  JLabel date = new JLabel();
  JLabel time = new JLabel();
  BorderLayout borderLayout16 = new BorderLayout();
  JLabel padding3 = new JLabel();
  JLabel padding4 = new JLabel();
  JPanel jPanel18 = new JPanel();
  JLabel jLabel1 = new JLabel();

  /**Construct the frame*/
  public AlarmClock() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);

    // initialize variables that control the clock
    oldDate = (Calendar.getInstance().get(Calendar.MONTH)+1) + "/" +
              Calendar.getInstance().get(Calendar.DAY_OF_MONTH) + "/" +
              Calendar.getInstance().get(Calendar.YEAR);

    oldTime = Calendar.getInstance().get(Calendar.HOUR_OF_DAY) + ":" +
              Calendar.getInstance().get(Calendar.MINUTE) + ":" +
              Calendar.getInstance().get(Calendar.SECOND);

    priorTime = Calendar.getInstance().getTime().getTime();

    //Other inicializations
    random = new Random();
    String fileName = "Log_"+Calendar.getInstance().getTime().getTime();
    File f = new File(fileName);
    fw = null;

    try{
      if(f.exists())
         fw = new FileWriter(fileName, true); //File
      else
         fw = new FileWriter(fileName, false); //File
      }catch(Exception e){
        e.printStackTrace();
      }


    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    start();
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(AlarmClock.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(gridLayout2);
    this.setSize(new Dimension(400, 300));
    this.setTitle("Digital Alarm Clock");
    jPanel1.setLayout(borderLayout1);

    stopAlarmButton.setBackground(Color.white);
    stopAlarmButton.setMaximumSize(new Dimension(90, 12));
    stopAlarmButton.setMinimumSize(new Dimension(90, 12));
    stopAlarmButton.setPreferredSize(new Dimension(90, 12));
    //stopAlarmButton.setFont(new java.awt.Font("Dialog", 1, 13));
   // stopAlarmButton.setForeground(UIManager.getColor("Tree.editorBorderSelectionColor"));
    stopAlarmButton.setToolTipText("Stop the alarm when its ring");
    stopAlarmButton.setActionMap(null);
    stopAlarmButton.setActionCommand("STOP");
    stopAlarmButton.setBackground(Color.white);
    stopAlarmButton.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          if (isRinging){
              alarmStoped = true;
              isRinging = false;
              try{
                fw.write(Calendar.getInstance().getTime().getTime()+" Finish Ringing\n");
              }catch(Exception ee){}
              if(clip!=null){
                clip.stop();
                clip.close();
              }
            }
      }
    });

   // stopAlarmButton.setText("STOP Alarm");

    contentPane.setBackground(Color.white);
    contentPane.setMinimumSize(new Dimension(533, 284));
    jPanel1.setBackground(Color.lightGray);
    jPanel1.setMinimumSize(new Dimension(533, 284));
    jPanel1.setPreferredSize(new Dimension(533, 284));
    jPanel3.setLayout(borderLayout3);
    setAlarmTimes.setBackground(Color.lightGray);
    setAlarmTimes.setFont(new java.awt.Font("Dialog", 1, 12));
    setAlarmTimes.setToolTipText("");
    setAlarmTimes.setText("Settings of weekly ringing times:");
    jPanel5.setLayout(borderLayout4);
    jPanel6.setLayout(borderLayout5);
    jPanel7.setLayout(borderLayout6);
    jPanel8.setLayout(borderLayout7);
    jPanel9.setLayout(borderLayout8);
    jPanel10.setLayout(borderLayout9);
    jPanel11.setLayout(borderLayout10);
    alarmSunday.setBackground(Color.white);
    alarmSunday.setText("hh:mm");
    sundayCheckBox.setBackground(Color.lightGray);
    sundayCheckBox.setToolTipText("Set the alarm clock to rings on  Sunday");
    sundayCheckBox.setHorizontalAlignment(SwingConstants.CENTER);
    sundayCheckBox.setText("Sun");
    jPanel4.setBackground(Color.lightGray);
    mondayCheckBox.setText("Mon");
    mondayCheckBox.setHorizontalAlignment(SwingConstants.CENTER);
    mondayCheckBox.setBackground(Color.lightGray);
    mondayCheckBox.setToolTipText("Set the alarm clock to rings on  Monday");
    alarmMonday.setText("hh:mm");
    alarmMonday.setBackground(Color.white);
    tuesdayCheckBox.setText("Tue");
    tuesdayCheckBox.setHorizontalAlignment(SwingConstants.CENTER);
    tuesdayCheckBox.setBackground(Color.lightGray);
    tuesdayCheckBox.setToolTipText("Set the alarm clock to rings on  Tuesday");
    alarmTuesday.setText("hh:mm");
    alarmTuesday.setBackground(Color.white);
    alarmTuesday.setToolTipText("Enter the ringing time (hh:mm)");
    wednesdayCheckBox.setText("Wed");
    wednesdayCheckBox.setHorizontalAlignment(SwingConstants.CENTER);
    wednesdayCheckBox.setBackground(Color.lightGray);
    wednesdayCheckBox.setToolTipText("Set the alarm clock to rings on  Wednesday");
    alarmWednesday.setText("hh:mm");
    alarmWednesday.setBackground(Color.white);
    thusdayCheckBox.setText("Thu");
    thusdayCheckBox.setHorizontalAlignment(SwingConstants.CENTER);
    thusdayCheckBox.setBackground(Color.lightGray);
    thusdayCheckBox.setToolTipText("Set the alarm clock to rings on  Thusday");
    alarmThusday.setText("hh:mm");
    alarmThusday.setBackground(Color.white);
    alarmFriday.setBackground(Color.white);
    alarmFriday.setText("hh:mm  ");

    fridayCheckBox.setToolTipText("Set the alarm clock to rings on  Friday");
    fridayCheckBox.setBackground(Color.lightGray);
    fridayCheckBox.setHorizontalAlignment(SwingConstants.CENTER);
    fridayCheckBox.setText("Fri");
    fridayCheckBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        fridayCheckBox_actionPerformed(e);
      }
    });
    saturdayCheckBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        saturdayCheckBox_actionPerformed(e);
      }
    });
    saturdayCheckBox.setText("Sat");
    saturdayCheckBox.setHorizontalAlignment(SwingConstants.CENTER);
    saturdayCheckBox.setBackground(Color.lightGray);
    saturdayCheckBox.setToolTipText("Set the alarm clock to rings on  Saturday");
    alarmSaturday.setText("hh:mm  ");
    alarmSaturday.setBackground(Color.white);
        alarmSaturday.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
              try{
                fw.write(Calendar.getInstance().getTime().getTime()+" Finish Seting on Saturday\n");
              }catch(Exception ee){}
      }
    });


    jPanel3.setBackground(Color.lightGray);
    padding.setText(" ");
    jPanel12.setLayout(borderLayout11);
    newDateField.setBackground(Color.white);
    newDateField.setToolTipText("Sets a new date to the clock (mm/dd/aa, mm/dd/aaaa, mm-dd-aa, mm-dd-aaaa)");
    newDateField.setSelectionStart(0);
    newDateField.setText((Calendar.getInstance().get(Calendar.MONTH)+1) + "/" +
                         Calendar.getInstance().get(Calendar.DAY_OF_MONTH) + "/" +
                         Calendar.getInstance().get(Calendar.YEAR));
    setDateLabel.setBackground(Color.lightGray);
    setDateLabel.setFont(new java.awt.Font("Dialog", 1, 12));
    setDateLabel.setText("Set new date :  ");
    jPanel16.setLayout(borderLayout15);
    jPanel12.setBackground(Color.lightGray);
    jPanel16.setBackground(Color.lightGray);
    jPanel13.setLayout(borderLayout12);
    jPanel15.setLayout(borderLayout14);
    setDateLabel1.setText("Set new time :  ");
    setDateLabel1.setFont(new java.awt.Font("Dialog", 1, 12));
    setDateLabel1.setBackground(Color.lightGray);
    jPanel14.setLayout(borderLayout13);
    jPanel14.setBackground(Color.lightGray);
    newTimeField.setText(Calendar.getInstance().get(Calendar.HOUR_OF_DAY) + ":" +
                         Calendar.getInstance().get(Calendar.MINUTE) + ":" +
                         Calendar.getInstance().get(Calendar.SECOND));
     newTimeField.setToolTipText("Sets a new time (hh:mm:ss,  hh:mm)");
    newTimeField.setBackground(Color.white);
    padding1.setBackground(Color.lightGray);
    padding1.setFont(new java.awt.Font("Dialog", 1, 12));
    padding1.setToolTipText("");
    padding1.setText(" ");
    jPanel15.setBackground(Color.lightGray);
    jPanel13.setBackground(Color.lightGray);
    padding2.setText(" ");
    padding2.setToolTipText("");
    padding2.setFont(new java.awt.Font("Dialog", 1, 12));
    padding2.setBackground(Color.lightGray);
    jPanel2.setLayout(borderLayout2);
    jPanel17.setBorder(BorderFactory.createLoweredBevelBorder());
    jPanel17.setBackground(Color.white);
    jPanel17.setLayout(borderLayout16);
    date.setBackground(Color.white);
    date.setFont(new java.awt.Font("Dialog", 1, 17));

    date.setForeground(new Color(0, 131, 0));
    date.setAlignmentX((float) 100.0);
   // date.setDisplayedMnemonic('0');

    time.setBackground(Color.white);
    time.setFont(new java.awt.Font("SansSerif", 0, 45));
    time.setForeground(Color.red);
    time.setRequestFocusEnabled(false);
    padding3.setBackground(Color.lightGray);
    padding3.setFont(new java.awt.Font("Dialog", 1, 12));
    padding3.setToolTipText("");
    padding3.setText("  ");
    padding4.setText("  ");
    padding4.setToolTipText("");
    padding4.setFont(new java.awt.Font("Dialog", 1, 12));
    padding4.setBackground(Color.lightGray);
    jPanel2.setBackground(Color.lightGray);
    jLabel1.setBackground(Color.lightGray);
    jLabel1.setFont(new java.awt.Font("Dialog", 1, 16));
    jLabel1.setText("Digital Alarm Clock");
    jPanel18.setBackground(Color.lightGray);
    contentPane.add(jPanel1, null);
    jPanel1.add(stopAlarmButton, BorderLayout.EAST);
    jPanel1.add(jPanel3, BorderLayout.SOUTH);
    jPanel3.add(setAlarmTimes,  BorderLayout.CENTER);
    jPanel3.add(jPanel4, BorderLayout.SOUTH);
    jPanel4.add(jPanel5, null);
    jPanel4.add(jPanel6, null);
    jPanel4.add(jPanel7, null);
    jPanel4.add(jPanel8, null);
    jPanel8.add(wednesdayCheckBox, BorderLayout.CENTER);
    jPanel8.add(alarmWednesday, BorderLayout.SOUTH);
    jPanel4.add(jPanel9, null);
    jPanel9.add(thusdayCheckBox, BorderLayout.CENTER);
    jPanel9.add(alarmThusday, BorderLayout.SOUTH);
    jPanel4.add(jPanel10, null);
    jPanel4.add(jPanel11, null);
    jPanel5.add(alarmSunday, BorderLayout.CENTER);
    jPanel5.add(sundayCheckBox, BorderLayout.NORTH);
    jPanel6.add(mondayCheckBox, BorderLayout.CENTER);
    jPanel6.add(alarmMonday, BorderLayout.SOUTH);
    jPanel7.add(tuesdayCheckBox, BorderLayout.CENTER);
    jPanel7.add(alarmTuesday, BorderLayout.SOUTH);
    jPanel10.add(alarmFriday, BorderLayout.SOUTH);
    jPanel10.add(fridayCheckBox, BorderLayout.CENTER);
    jPanel11.add(saturdayCheckBox, BorderLayout.CENTER);
    jPanel11.add(alarmSaturday, BorderLayout.SOUTH);
    jPanel3.add(padding, BorderLayout.NORTH);
    jPanel1.add(jPanel12,  BorderLayout.WEST);
    jPanel1.add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jPanel17,  BorderLayout.CENTER);
    jPanel17.add(date, BorderLayout.NORTH);
    jPanel17.add(time, BorderLayout.CENTER);
    jPanel2.add(padding3,  BorderLayout.WEST);
    jPanel2.add(padding4,  BorderLayout.EAST);
    jPanel1.add(jPanel18, BorderLayout.NORTH);
    jPanel18.add(jLabel1, null);
    jPanel16.add(newDateField, BorderLayout.SOUTH);
    jPanel16.add(setDateLabel, BorderLayout.NORTH);
    jPanel12.add(jPanel13, BorderLayout.CENTER);
    jPanel13.add(jPanel15,  BorderLayout.CENTER);
    jPanel15.add(jPanel14, BorderLayout.NORTH);
    jPanel14.add(setDateLabel1, BorderLayout.NORTH);
    jPanel14.add(newTimeField, BorderLayout.SOUTH);
    jPanel13.add(padding1, BorderLayout.SOUTH);
    jPanel13.add(padding2, BorderLayout.NORTH);
    jPanel12.add(jPanel16, BorderLayout.NORTH);

    alarmStrings = new String[8];
    alarmStrings[0] = "";
    alarmStrings[1] = alarmSunday.getText();
    alarmStrings[2] = alarmMonday.getText();
    alarmStrings[3] = alarmTuesday.getText();
    alarmStrings[4] = alarmWednesday.getText();
    alarmStrings[5] = alarmThusday.getText();
    alarmStrings[6] = alarmFriday.getText();
    alarmStrings[7] = alarmSaturday.getText();

  }

  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
    try{
      fw.close();
    }catch(Exception ee){}

      System.exit(0);
    }
  }

  void fridayCheckBox_actionPerformed(ActionEvent e) {
    try{
     fw.write(Calendar.getInstance().getTime().getTime()+" click on friday checkbox\n");
    }catch(Exception ee){}

  }
  void saturdayCheckBox_actionPerformed(ActionEvent e) {
    try{
     fw.write(Calendar.getInstance().getTime().getTime()+" click on saturday checkbox\n");
    }catch(Exception ee){}

  }

  /**
   * Plays the alarm sounds
   */
   public void playAlarmSounds(){

    String[] soundFiles = { "bird.au",
                            "geese.au",
                            "hen-1.au",
                            "owl.au",
                            "pig.au",
                            "rooster.au",
                            "wolf-1.au",
                            "wolf-2.au"};


      try {
         // From file
         AudioInputStream stream =
           AudioSystem.getAudioInputStream(
             new File(soundFiles[random.nextInt(soundFiles.length)]));

         // At present, ALAW and ULAW encodings must be converted
         // to PCM_SIGNED before it can be played.
         AudioFormat format = stream.getFormat();
         if (format.getEncoding() !=
           AudioFormat.Encoding.PCM_SIGNED) {
             format = new AudioFormat(
                     AudioFormat.Encoding.PCM_SIGNED,
                     format.getSampleRate(),
                     format.getSampleSizeInBits()*2,
                     format.getChannels(),
                     format.getFrameSize()*2,
                     format.getFrameRate(),
                     true);        // big endian
             stream = AudioSystem.getAudioInputStream(
               format, stream);
         }
         DataLine.Info info = new DataLine.Info(
             Clip.class, stream.getFormat(),

            //The next two lines should be in one line.
               ((int)stream.getFrameLength(
                 )*format.getFrameSize()));

         clip = (Clip) AudioSystem.getLine(info);

         // This method does not return until the audio
             //file is completely loaded.
         clip.open(stream);
         //clip.loop(clip.LOOP_CONTINUOUSLY);
         // Start playing.
         clip.start();


     } catch (Exception e) {
      e.printStackTrace();
     }
   }


  /**
   * parses the string passed by paramenter to a vector of ints
   *
   * @param stringToParse - the string that will be parser into integers
   * @param delimiters - the delimiters used to separate the string
   *
   * @return int[] a vector with the parsed values
   */
  private int[] parseToInt(String stringToParse, String delimiter){
      StringTokenizer timeToken = new StringTokenizer(stringToParse,delimiter);
      int [] values = new int[3];
      int index =0;

      // broke the string in parts
      while(timeToken.hasMoreTokens()){
        try{
          values[index++] = Integer.parseInt(timeToken.nextToken())  ;
        }catch(Exception e){
         // Invalid Format probably
         // e.printStackTrace();
        }
      }
      return values;
  }


  /**
   * Checks if it should rings the alarm
   */
  public void checkAlarms(){

    //verify if the alarm is ringing or if was stoped
    if(!alarmStoped)
     switch(lastAllarm.get(Calendar.DAY_OF_WEEK)){
       case 1: if(sundayCheckBox.isSelected()){
                  int [] alarm = this.parseToInt(alarmSunday.getText(),": ");
                  if (isRinging || ((alarm.length>1) &&
                      (lastAllarm.get(Calendar.HOUR_OF_DAY) == alarm[0]) &&
                      (lastAllarm.get(Calendar.MINUTE) == alarm[1]))){
                        if(!isRinging)
                          try{
                            fw.write(Calendar.getInstance().getTime().getTime()+" Init Ringing\n");
                          }catch(Exception ee){}
                        isRinging = true;
                        if(clip==null || !clip.isRunning())
                          playAlarmSounds();
                      }
               }
               break;
        case 2: if(mondayCheckBox.isSelected()){
                  int [] alarm = this.parseToInt(alarmMonday.getText(),": ");
                  if (isRinging || ((alarm.length>1) &&
                      (lastAllarm.get(Calendar.HOUR_OF_DAY) == alarm[0]) &&
                      (lastAllarm.get(Calendar.MINUTE) == alarm[1]))){
                        if(!isRinging)
                          try{
                            fw.write(Calendar.getInstance().getTime().getTime()+" Init Ringing\n");
                          }catch(Exception ee){}
                        isRinging = true;
                        if(clip==null || !clip.isRunning())
                          playAlarmSounds();
                      }
               }
               break;
        case 3: if(tuesdayCheckBox.isSelected()){
                  int [] alarm = this.parseToInt(alarmTuesday.getText(),": ");
                  if (isRinging || ((alarm.length>1) &&
                      (lastAllarm.get(Calendar.HOUR_OF_DAY) == alarm[0]) &&
                      (lastAllarm.get(Calendar.MINUTE) == alarm[1]))){
                        if(!isRinging)
                          try{
                            fw.write(Calendar.getInstance().getTime().getTime()+" Init Ringing\n");
                          }catch(Exception ee){}
                        isRinging = true;
                        if(clip==null || !clip.isRunning())
                          playAlarmSounds();
                      }
               }
               break;
        case 4: if(wednesdayCheckBox.isSelected()){
                  int [] alarm = this.parseToInt(alarmWednesday.getText(),": ");
                  if (isRinging || ((alarm.length>1) &&
                      (lastAllarm.get(Calendar.HOUR_OF_DAY) == alarm[0]) &&
                      (lastAllarm.get(Calendar.MINUTE) == alarm[1]))){
                        if(!isRinging)
                          try{
                            fw.write(Calendar.getInstance().getTime().getTime()+" Init Ringing\n");
                          }catch(Exception ee){}
                        isRinging = true;
                        if(clip==null || !clip.isRunning())
                          playAlarmSounds();
                      }
               }
               break;
        case 5: if(thusdayCheckBox.isSelected()){
                  int [] alarm = this.parseToInt(alarmThusday.getText(),": ");
                  if (isRinging || ((alarm.length>1) &&
                      (lastAllarm.get(Calendar.HOUR_OF_DAY) == alarm[0]) &&
                      (lastAllarm.get(Calendar.MINUTE) == alarm[1]))){
                        if(!isRinging)
                          try{
                            fw.write(Calendar.getInstance().getTime().getTime()+" Init Ringing\n");
                          }catch(Exception ee){}
                        isRinging = true;
                        if(clip==null || !clip.isRunning())
                          playAlarmSounds();
                      }
               }
               break;
        case 6: if(fridayCheckBox.isSelected()){
                  int [] alarm = this.parseToInt(alarmFriday.getText(),": ");
                  if (isRinging || ((alarm.length>1) &&
                      (lastAllarm.get(Calendar.HOUR_OF_DAY) == alarm[0]) &&
                      (lastAllarm.get(Calendar.MINUTE) == alarm[1]))){
                        if(!isRinging)
                          try{
                            fw.write(Calendar.getInstance().getTime().getTime()+" Init Ringing\n");
                          }catch(Exception ee){}
                        isRinging = true;
                        if(clip==null || !clip.isRunning())
                          playAlarmSounds();
                      }
               }
               break;
        case 7: if(saturdayCheckBox.isSelected()){
                  int [] alarm = this.parseToInt(alarmSaturday.getText(),": ");
                  if (isRinging || ((alarm.length>1) &&
                      (lastAllarm.get(Calendar.HOUR_OF_DAY) == alarm[0]) &&
                      (lastAllarm.get(Calendar.MINUTE) == alarm[1]))){
                        if(!isRinging)
                           try{
                            fw.write(Calendar.getInstance().getTime().getTime()+" Init Ringing\n");
                          }catch(Exception ee){}
                       isRinging = true;
                        if(clip==null || !clip.isRunning())
                          playAlarmSounds();
                      }
               }
               break;
        default:  System.out.println("???");
     }

 //    System.out.println(" day " + Calendar.getInstance().get(Calendar.DAY_OF_WEEK) +
 //                       "saturday value" + alarmSaturday.getText() +
 //                       "old value" + alarmStrings[7]);
     // Verify if the alarm was changed
    if((lastAllarm.get(Calendar.DAY_OF_WEEK) == Calendar.SUNDAY) &&
        (!alarmSunday.getText().equals(alarmStrings[1]))){
         alarmStrings[1]=new String(alarmSunday.getText());
         alarmStoped = false;
        try{
          fw.write(Calendar.getInstance().getTime().getTime()+" Changed Alarm\n");
       }catch(Exception ee){}
    }else
     if((lastAllarm.get(Calendar.DAY_OF_WEEK) == Calendar.MONDAY) &&
        (!alarmMonday.getText().equals(alarmStrings[2]))){
         alarmStrings[2]=new String(alarmMonday.getText());
         alarmStoped = false;
        try{
          fw.write(Calendar.getInstance().getTime().getTime()+" Changed Alarm\n");
       }catch(Exception ee){}
     } else
     if((lastAllarm.get(Calendar.DAY_OF_WEEK) == Calendar.TUESDAY) &&
        (!alarmTuesday.getText().equals(alarmStrings[3]))){
         alarmStrings[3]=new String(alarmTuesday.getText());
         alarmStoped = false;
        try{
          fw.write(Calendar.getInstance().getTime().getTime()+" Changed Alarm\n");
       }catch(Exception ee){}
     } else
     if((lastAllarm.get(Calendar.DAY_OF_WEEK) == Calendar.WEDNESDAY) &&
        (!alarmWednesday.getText().equals(alarmStrings[4]))){
         alarmStrings[4]=new String(alarmWednesday.getText());
         alarmStoped = false;
        try{
          fw.write(Calendar.getInstance().getTime().getTime()+" Changed Alarm\n");
       }catch(Exception ee){}
     } else
     if((lastAllarm.get(Calendar.DAY_OF_WEEK) == Calendar.THURSDAY) &&
        (!alarmThusday.getText().equals(alarmStrings[5]))){
         alarmStrings[5]=new String(alarmThusday.getText());
         alarmStoped = false;
        try{
          fw.write(Calendar.getInstance().getTime().getTime()+" Changed Alarm\n");
       }catch(Exception ee){}
     } else
     if((lastAllarm.get(Calendar.DAY_OF_WEEK) == Calendar.FRIDAY) &&
        (!alarmFriday.getText().equals(alarmStrings[6]))){
         alarmStrings[6]=new String(alarmFriday.getText());
         alarmStoped = false;
        try{
          fw.write(Calendar.getInstance().getTime().getTime()+" Changed Alarm\n");
       }catch(Exception ee){}
     } else
     if((lastAllarm.get(Calendar.DAY_OF_WEEK) == Calendar.SATURDAY) &&
        (!alarmSaturday.getText().equals(alarmStrings[7]))){
         alarmStrings[7]=new String(alarmSaturday.getText());
         alarmStoped = false;
        try{
          fw.write(Calendar.getInstance().getTime().getTime()+" Changed Alarm\n");
       }catch(Exception ee){}
     }
  }
  /**
   * Change the date
   */
  public synchronized void changeDate(){
    String newDate = newDateField.getText();
    if(!newDate.equals(oldDate)){
       try{
          fw.write(Calendar.getInstance().getTime().getTime()+" Changed Date\n");
       }catch(Exception ee){}
      StringTokenizer dateToken = new StringTokenizer(newDate,"-/ ");
      int [] values = new int[3];
      int index =0;

      // broke the new date in parts
      while(dateToken.hasMoreTokens()){
        try{
          if(index == 0) // the months starts in 0 so we need to subtract 1
            values[index++] = Integer.parseInt(dateToken.nextToken()) -1;
          else
            values[index++] = Integer.parseInt(dateToken.nextToken()) ;
        }catch(Exception e){
          e.printStackTrace();
        }
      }

      //just to guarantee that if you change the setings the new
      // alarm will be observed
      if(alarmStoped)
        alarmStoped = false;

      // transfer the new date to the calendar
      if(index>0){
        if(values[0] == 12)
          values[0] = 0;
        lastAllarm.set(Calendar.MONTH, values[0]);
        if(index>1){
          lastAllarm.set(Calendar.DAY_OF_MONTH, values[1]);
          if(index>2){

            //if the Gui entered the year just with 2 digits
            if(values[2]<100)
              values[2]+=2000;
            lastAllarm.set(Calendar.YEAR, values[2]);
          }
        }
      }

   }
    // saves the new value
    oldDate=newDate;
  }

  /**
   * Change the time
   */
  public synchronized void changeTime(){
    String newTime = newTimeField.getText();
    if(!newTime.equals(oldTime)){
       try{
          fw.write(Calendar.getInstance().getTime().getTime()+" Changed Time\n");
       }catch(Exception ee){}

      StringTokenizer timeToken = new StringTokenizer(newTime,": ");
      int [] values = new int[3];
      int index =0;

      // broke the new time in parts
      while(timeToken.hasMoreTokens()){
        try{
          values[index++] = Integer.parseInt(timeToken.nextToken())  ;
        }catch(Exception e){
          e.printStackTrace();
        }
      }

      //just to guarantee that if you change the setings the new
      // alarm will be observed
      if(alarmStoped)
        alarmStoped = false;

      // transfer the new time to the calendar
      if(index>0){
        lastAllarm.set(Calendar.HOUR_OF_DAY, values[0]);
        if(index>1){
          lastAllarm.set(Calendar.MINUTE, values[1]);
          if(index>2){
            lastAllarm.set(Calendar.SECOND, values[2]);
          }
        }
      }

    }

    // saves the new value
    oldTime=newTime;
  }

 /**
  * Update periodically the time
  */
 public synchronized void updateTime(){
    Date newDate = lastAllarm.getTime();

    // calculates the difference passed during the proscessing time to
    // mantain the clock accurate
    long diference = Calendar.getInstance().getTime().getTime() - priorTime;
    newDate.setTime(lastAllarm.getTime().getTime() +diference);
    priorTime = Calendar.getInstance().getTime().getTime();

    lastAllarm.setTime(newDate);
    String dayOfWeek;

    // Find the week day correspondent to the passed date
    switch(lastAllarm.get(Calendar.DAY_OF_WEEK)){
      case 1: dayOfWeek = "Sunday - ";
         break;
      case 2: dayOfWeek = "Monday - ";
         break;
      case 3: dayOfWeek = "Tuesday - ";
         break;
      case 4: dayOfWeek = "Wednesday - ";
         break;
      case 5: dayOfWeek = "Thursday - ";
         break;
      case 6: dayOfWeek = "Friday - ";
         break;
      case 7: dayOfWeek = "Saturday - ";
         break;
      default:
        dayOfWeek = "??";
    }

    // the months starts with 0 so ad one to show on screen
    int month = lastAllarm.get(Calendar.MONTH)+1;
    date.setText(dayOfWeek +
                 month + "/" +
                 lastAllarm.get(Calendar.DAY_OF_MONTH) + "/" +
                 lastAllarm.get(Calendar.YEAR));

    int minute = lastAllarm.get(Calendar.MINUTE);
    String minute_str = (minute < 10)? ("0" + minute): ("" + minute);
    int second = lastAllarm.get(Calendar.SECOND);
    String second_str = (second < 10)? ("0" + second): ("" + second);

    time.setText(" " + lastAllarm.get(Calendar.HOUR_OF_DAY) + ":" +
                       minute_str + ":" +
                       second_str);
  }
  public void run(){
    while(true){
     // lastAllarm = Calendar.getInstance(lastAllarm).getTime().getTime();
      changeDate();
      changeTime();
      checkAlarms();
      updateTime();

  //    jPanel17.setVisible(true);
      try{
        Thread.sleep(100);
      }catch(Exception e){
        e.printStackTrace();
      }

    }


  }

    /**
     * This method is called when the application becomes visible on
     * the screen. Create a thread and start it.
     */
    public void start() {
	thread = new Thread(this);
	thread.start();
    }

    /**
     * Handles the events trigered on the alarm screen
     */
    public boolean action(Event evt, Object arg) {
        String receivedArg = (String) arg;
        System.out.println(" Event : " + receivedArg);
        return true;
    }



    public static void main(String[] args) {
      AlarmClock alarmClock = new AlarmClock();
      alarmClock.show();
  }

}